<template>
    <v-tabs vertical color="error" v-model="tab">
      <v-tab>
        <v-icon left>mdi-notification-clear-all</v-icon>All
      </v-tab>
      <v-tab>
        <v-icon left>mdi-emoticon-cry</v-icon>User
      </v-tab>
      <v-tab>
        <v-icon left>mdi-sigma</v-icon>Checksum
      </v-tab>
      <v-tab>
        <v-icon left>mdi-close-circle-outline</v-icon>Other
      </v-tab>
      <v-tabs-items v-model="tab">
        <v-tab-item>
          <v-list-item two-line v-for="(error, i) in errors" :key="'error'+i">
            <v-list-item-avatar>
              <v-icon>{{error.type}}</v-icon>
            </v-list-item-avatar>
            <v-list-item-content>
              <v-list-item-title>{{error.message}}</v-list-item-title>
              <v-list-item-subtitle>{{new Date(error.timestamp).toLocaleTimeString()}}</v-list-item-subtitle>
            </v-list-item-content>
          </v-list-item>
        </v-tab-item>
        <ErrorTab
          v-for="(n, index) in errors_types.length"
          :key="n+index"
          :icon="errors_types[index].icon"
          :errorType="errors_types[index].identifier"
        />
      </v-tabs-items>
    </v-tabs>
</template>

<script>
import { ErrorType } from "@/plugins/data_structures/Enums";
import ErrorTab from "./ErrorTab";

export default {
  name: "ErrorsVisualizer",
  components: {
    ErrorTab,
  },
  data: () => ({
    tab: 0,
    errors_types: [
      {
        identifier: ErrorType.USER,
        name: "User defined error",
        icon: "mdi-emoticon-cry",
      },
      {
        identifier: ErrorType.CHECKSUM,
        name: "Checksum error",
        icon: "mdi-sigma",
      },
      {
        identifier: ErrorType.OTHER,
        name: "Unknown error",
        icon: "mdi-close-circle-outline",
      },
    ],
  }),
  computed: {
    errors() {
      return this.$store.getters["coms/errors"];
    },
  },
};
</script>